<?php

defined('_JEXEC') or die( 'Restricted access');

jimport('joomla.application.component.model');

class KideModelKide extends JModel {
	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	
	function __construct() {
		parent::__construct();
		
		global $mainframe, $option;
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
		
		if ($limit) {
			$limitstart = floor($limitstart / $limit) * $limit;
		}
		
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	function getData() {
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	
	function delete($cid = array()) {
		$result = false;

		if (count($cid)) {
			JArrayHelper::toInteger($cid);
			$cids = implode(',', $cid);
			$query = 'DELETE FROM #__kide'
				. ' WHERE id IN ('.$cids.')';
			$this->_db->setQuery($query);
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}

	function getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	
	function querySearch($search, $table) {
		
		require_once(dirname(dirname(__file__)).DS."tables".DS.$table.".php");
			
		$colums = get_class_vars("TableCatalog");
		$where = array();
			
		foreach ($colums as $colum) {
			if (substr($colum, 0, 1) != "_") {
				$where[] = 'LOWER(a.'.$colum.') LIKE '.$db->Quote( '%'.$db->getEscaped($search, true).'%', false);
			}
		}
			
		return ' WHERE '.implode(' OR ', $where);
	}

	function _buildQuery() {
		global $mainframe, $option;
		
		$table = JRequest::getVar('table', "kide", "POST");
		$search = $mainframe->getUserStateFromRequest($option.'search', 'search', '', 'string');
		$db =& JFactory::getDBO();
		$query = 'SELECT a.* FROM #__'.$table.' AS a';
		
		if ($search) {
			$query .= $this->querySearch($search, $table);
		}
		
		$query .= ' ORDER BY';
		
		$query .= " ".$mainframe->getUserStateFromRequest($option.'filter_order',		'filter_order',		'a.id',	'cmd');
		$query .= " ".$mainframe->getUserStateFromRequest($option.'filter_order_Dir',	'filter_order_Dir',	'',		'word');
		
		return $query;
	}
}
