<?php

class kideUserConfig {
	var $config = array();
	var $version = 2;
	var $name = "kide_config";

	function __construct() {
		if ($this->cookie($this->name)) {
			$this->config = $this->getArray($this->cookie($this->name));
		}
		if (!isset($this->config["v"]) || (int)$this->config["v"] < $this->version) {
			$this->config = array();
			setcookie($this->name, "v=".$this->version.";", time() + 3600 * 24 * 30, "/");
			$this->config["v"] = $this->version;
		}
	}
	
	function &getInstance(){
		static $instance;
		if (!is_object($instance)) {
			$instance = new kideUserConfig();
		}
		return $instance;
	}
	
	function getArray($config) {
		$opciones = explode(";", substr($config,0,-1));
		$aux = array();
		foreach ($opciones as $opcion) {
			$opcion = explode("=", $opcion);
			$aux[$opcion[0]] = $opcion[1];
		}
		return $aux;
	}
	
	function getString($config) {
		$return = "";
		foreach ($config as $key=>$value) {
			$return .= "$key=$value;";
		}
		return $return;
	}
	
	function save($param, $value="") {
		$this->config[$param] = $value;
		setcookie($this->name, $this->getString($this->config), time() + 3600 * 24 * 30, "/");
	}

	function load($param, $default=null) {
		return isset($this->config[$param]) ? $this->config[$param] : $default;
	}

	function get($g, $d=null) {
		return isset($_GET[$g]) ? $_GET[$g] : $d;
	}

	function post($p, $d=null) {
		return isset($_POST[$p]) ? $_POST[$p] : $d;
	}

	function server($s, $d=null) {
		return isset($_SERVER[$s]) ? $_SERVER[$s] : $d;
	}
	
	function cookie($c, $d=null) {
		return isset($_COOKIE[$c]) ? $_COOKIE[$c] : $d;
	}
}

$kconfig =& kideUserConfig::getInstance();

if ($kconfig->get('param') && $kconfig->get('funcion')) {
	
	header("Content-Type: text/html; charset=utf-8");
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Cache-Control: no-store, no-cache, must-revalidate");
	header("Cache-Control: post-check=0, pre-check=0", false);
	header("Pragma: no-cache");
	
	if ($kconfig->get('funcion') == "load") {
		echo $kconfig->load($kconfig->get('param'));
	}
	else {	
		$kconfig->save($kconfig->get('param'), $kconfig->get('value'));
	}
}